commit 5759b5f4af2d7ad09e0ad04be95fb26244d4e726
Author: Richard Biener <rguenther@suse.de>
Date:   Mon Feb 3 14:27:01 2025 +0100

    lto/113207 - fix free_lang_data_in_type
    
    When we process function types we strip volatile and const qualifiers
    after building a simplified type variant (which preserves those).
    The qualified type handling of both isn't really compatible, so avoid
    bad interaction by swapping this, first dropping const/volatile
    qualifiers and then building the simplified type thereof.
    
            PR lto/113207
            * ipa-free-lang-data.cc (free_lang_data_in_type): First drop
            const/volatile qualifiers from function argument types,
            then build a simplified type.
    
            * gcc.dg/pr113207.c: New testcase.
    
    (cherry picked from commit a55e14b239181381204c615335929b3316d75370)

diff --git a/gcc/testsuite/gcc.dg/pr113207.c b/gcc/testsuite/gcc.dg/pr113207.c
new file mode 100644
index 00000000000..81f53d8fcc2
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr113207.c
@@ -0,0 +1,10 @@
+/* { dg-compile } */
+/* { dg-require-effective-target lto } */
+/* { dg-options "-flto -fchecking" }  */
+
+typedef struct cl_lispunion *cl_object;
+struct cl_lispunion {};
+cl_object cl_error() __attribute__((noreturn));
+volatile cl_object cl_coerce_value0;
+void cl_coerce() { cl_error(); }
+void L66safe_canonical_type(cl_object volatile);

